local THIS_ADDON, data = ...
local GH = GarrisonHelper
-- Frame and Events
local GarrisonHelper_Events = CreateFrame("Frame");
local events = {};

-- IDs http://www.wowhead.com/search?q=Work+Orders#npcs
GH.raidmarksIDs = {
	-- [building id] = {{skull npc ids},{cross npc ids}, ...}
	[8] = {{89065--[[dalana-clarke]],  89066--[[magrish]]},{77377,79815}},-- armory
	[40] ={{84248--[[justin-timberlord]], 84247--[[lumber-lord-oktron]]}},--mill
	--[61] ={{77730--[[timothy-leens]],     81688--[[Gorsol]]}},--excavation
	[24] ={{84524--[[homer-stonefield]],  85048--[[farmer-loklub]]}},--barn
	--[29] ={{85514--[[olly-nimkip]],       85783--[[nali-softsoil]]}},--garden
	[111]={{87207--[[trader-joseph]],     86803--[[fayla-fairfeather]]},{86779,87200,86778,87201,86776,87203,86777,87202,86683,87204}},--trading post
	[60] ={{77792--[[yulia-samras]],      79817--[[kinja]]}},--blacksmith
	[94] ={{77778--[[kaylie-macdonald]],  79863--[[turga]]}},--tailoring
	[93] ={{77781--[[garm]],              79820--[[garra]]}},--enchanting
	[95] ={{77777--[[kurt-broadoak]],     79831--[[yrogg]]}},--inscription
	[96] ={{77775--[[kaya-solasen]],      79830--[[elrondir-surrion]]}},--jewelcrafting
	[91] ={{77831--[[helayn-whent]],      86696--[[garbra-fizzwonk]]}},--engineering
	[90] ={{78207--[[marianne-levine]],   79833--[[yanney]]}},--leatherworking
	[76] ={{77791--[[peter-kearie]],      79814--[[keyana-tone]]}},--alchemy
	[37] ={{91582--[[apprentice-varnath]],91577--[[varsha]]}},--mage tower
}
GH.raidmarksTownHallNPCs ={	{86779,87200,86778,87201,86776,87203,86777,87202,86683,87204},
							{89763,89753,89805,89806,91024,91033,91025,91034,91020,91029,91404,91031,90894,91030,89793,92223}}

GH.garrisonMapIDs = {1158,1331,1159,1152,1330,1153,}
function GH:IsRaidMarksEnabled()
	return GH.db.profile.useraidmarks and not IsInGroup() and not IsInRaid()
end
function events.PLAYER_LOGIN()
	C_Timer.After(10, function() events.ZONE_CHANGED() end)
end
function GH:ScanGarrisonOverlayButton(anchor)
	if InCombatLockdown() then return end
	local macro = ""
	if GH:InsideGarrison() then
		for i=1,#GH.raidmarksTownHallNPCs do
			for j=1,#GH.raidmarksTownHallNPCs[i] do
				local npc = GH:NpcNameFromId(GH.raidmarksTownHallNPCs[i][j])
				if npc then
					-- don't know in other languages, but ten chars should be enough to target the right one
					macro = macro .. "/tar ".. string.sub(npc, 1,10) .. "\n"
					--macro = macro .. "/targetlasttarget\n"
				end
			end
		end
	end
	
	if GH.raidmarkmacro then 
		macro = GH.raidmarkmacro .. "\n" .. macro
	end
	--print(macro)
	--[[
		anchor may be the broker visualisation button or the minimap icon
		we put our own invisible button over it (same size, same position)
	]]
	if anchor then
		
		GH_OverlayButton = GH_OverlayButton or CreateFrame("Button", "GH_OverlayButton", UIParent, "SecureActionButtonTemplate")
		GH_OverlayButton:RegisterForClicks("LeftButtonUp", "RightButtonUp")
		GH_OverlayButton:RegisterForDrag("LeftButton")
		if #macro>0 then
			GH_OverlayButton:SetAttribute("type1", "macro"); -- left click
			GH_OverlayButton:SetAttribute("macrotext1", macro);
		else
			GH_OverlayButton:SetAttribute("type1", nil); -- left click
			GH_OverlayButton:SetAttribute("macrotext1", nil);
		end
		GH_OverlayButton:SetAttribute("type2", "macro");-- right click
		GH_OverlayButton:SetAttribute("macrotext2", "/gh");
		GH_OverlayButton:SetClampedToScreen(true);
		GH_OverlayButton:SetFrameStrata("TOOLTIP")
		
		GH_OverlayButton:SetWidth(anchor:GetWidth())
		GH_OverlayButton:SetHeight(anchor:GetHeight())
		GH_OverlayButton:SetAllPoints(anchor)
		
		GH_OverlayButton:SetScript("OnEnter", function(self) GH:BrokerTooltip(self) GH:ScanGarrisonOverlayButton(anchor) end);
		GH_OverlayButton:SetScript("OnLeave", function(self) GH.dataobj:OnLeave(self) end);
				
		-- use the scripts of the anchor to enable dragging
		GH_OverlayButton:SetScript("OnMouseDown", function() local f = anchor:GetScript("OnMouseDown") if f then f(anchor) end end)
		GH_OverlayButton:SetScript("OnMouseUp", function()  C_Timer.After(1, function() GH:BrokerTooltip(GH_OverlayButton) end) local f = anchor:GetScript("OnMouseUp") if f then f(anchor) end end)
		--GH_OverlayButton:SetScript("OnClick", function() C_Timer.After(1, function() GH:BrokerTooltip(GH_OverlayButton) end) end)
		if not anchor.db or not anchor.db.lock then
			GH_OverlayButton:SetScript("OnDragStart",  function() local f = anchor:GetScript("OnDragStart") if f then f(anchor) end end)
			GH_OverlayButton:SetScript("OnDragStop", function() local f = anchor:GetScript("OnDragStop") if f then f(anchor) end end)
		end
		
		--GH_OverlayButtonHighlight = GH_OverlayButtonHighlight or CreateFrame("Frame", "GH_OverlayButtonHighlight", GH_OverlayButton)
		if not GH_OverlayButton.highlight then
			GH_OverlayButton.highlight  = GH_OverlayButton:CreateTexture(nil, "ssHIGHLIGHT")
			GH_OverlayButton.highlight:SetAllPoints(true)
			GH_OverlayButton.highlight:SetTexture(1, 1, 0, 0.5)
			GH_OverlayButton.highlight:SetAlpha(0)
			--GH_HIGHLIGHT:Show()
		end
	end
	
end

function events.ZONE_CHANGED()
	if GH:IsRaidMarksEnabled() then
		for buildingID, npcs in pairs(GH.raidmarksIDs) do
			if GH:IsCurrentZoneThisBuilding(buildingID) then
				GH.formerZone = buildingID
				GH.currentNPCs = {}
				-- set raidmarks (cannot be done automatically)
				local t = ""
				local k = 8
				for i=1,#GH.raidmarksIDs[buildingID] do
					for j=1,#GH.raidmarksIDs[buildingID][i] do
						local npc = GH:NpcNameFromId(GH.raidmarksIDs[buildingID][i][j])
						if npc and not GH.currentNPCs[npc] then
							t = t .. "/tar ".. string.sub(npc, 1,10) .. "\n" 
							GH.currentNPCs[npc] = true
						end
					end
					t = t .. "/run if GetRaidTargetIndex('target') ~= "..k.." then SetRaidTarget('target',"..k..") end\n"
					k = k - 1
				end
				-- look for assigned NPC
				local npcName = GH:AssignedNPC(buildingID)
				if npcName then 
					t = t .. "/tar ".. string.sub(npcName, 1,10) .. "\n/run if GetRaidTargetIndex('target') ~= 1 then SetRaidTarget('target',1) end\n"
					GH.currentNPCs[npcName] = true
				end
				if #t>0 then
					local minimapicon
					if GH.minimapIcon then
						minimapicon = GH.minimapIcon:GetMinimapButton(THIS_ADDON)
					end
					if (minimapicon and minimapicon:IsVisible()) or GH.dataobj then -- we have a broker visualisation or minimap icon
						GH.raidmarkmacro = t
					else
						--no broker installed, show extra button
						local anchor = ExtraActionBarFrame
						GH:setActionButton(nil,t,L["click to target NPCs"], nil,nil,nil,nil,"Interface\\TargetingFrame\\UI-RaidTargetingIcons",anchor)
					end
				end
				break
			elseif GH.formerZone and GH.formerZone == buildingID then
				GH.formerZone = nil
				GH.currentNPCs = nil
				GH.raidmarkmacro = nil
				-- clear raidmarks (by marking yourself)
				for i=1,8 do SetRaidTarget("player",i) end
				SetRaidTarget("player",0)
				GH:destroy()
				break
			end
		end
	end
end
--[[
	Workaround: I don't want to localize the term "Town Hall", so I assume that if you are in your
	garrison and interact with the command table, that the location shown on the minimap
	is the term "Town Hall" in your language. Just do that once, I will remember this term.
]]

function events.GARRISON_MISSION_NPC_OPENED()
	if GH:InsideGarrison() then
		SetMapToCurrentZone()
		local zone = GetMinimapZoneText();
		if zone then
			GH.db.profile.localisedtownhall = zone
		end
	end
end

function GH:InsideGarrison()
	local id = select(8,GetInstanceInfo())
	for i=1,#GH.garrisonMapIDs do
		if GH.garrisonMapIDs[i]==id then
			return true
		end
	end
	return false
end

--[[
	when interacting with the NPC, the mark is obviously not needed anymore
]]
function events.QUEST_DETAIL()
	GH:RaidMarksClearRaidTarget()
end
function events.GOSSIP_SHOW()
	GH:RaidMarksClearRaidTarget()
end
function events.TRADE_SKILL_SHOW()
	GH:RaidMarksClearRaidTarget()
end
function GH:RaidMarksClearRaidTarget()
	if GH.currentNPCs and GH:IsRaidMarksEnabled() then
		local targetNPC = UnitName("target")
		if GH.currentNPCs[targetNPC] then
			SetRaidTarget('target',0)
			GH.currentNPCs[targetNPC] = false
		end
	end
end
-- register event listener
GarrisonHelper_Events:SetScript("OnEvent", function(self, event, ...) events[event](...); end);
for event, func in pairs(events) do GarrisonHelper_Events:RegisterEvent(event); end
